<?php
/**
 * Condition template.
 *
 * @package Cheshalo
 */

?>
<div class="xts-layout-condition-template xts-hidden">
	<div class="xts-layout-condition">
		<select class="xts-layout-condition-comparison" name="wd_layout_condition_comparison" aria-label="<?php esc_attr_e( 'Condition comparison', 'cheshalo' ); ?>">
			<option value="include">
				<?php esc_html_e( 'Include', 'cheshalo' ); ?>
			</option>
			<option value="exclude">
				<?php esc_html_e( 'Exclude', 'cheshalo' ); ?>
			</option>
		</select>

		<select class="xts-layout-condition-type" name="wd_layout_condition_type" data-type="shop_archive" aria-label="<?php esc_attr_e( 'Condition type', 'cheshalo' ); ?>">
			<option value="all">
				<?php esc_html_e( 'All product archives', 'cheshalo' ); ?>
			</option>
			<option value="shop_page">
				<?php esc_html_e( 'Shop page', 'cheshalo' ); ?>
			</option>
			<option value="product_search">
				<?php esc_html_e( 'Shop search results', 'cheshalo' ); ?>
			</option>
			<option value="product_cats">
				<?php esc_html_e( 'Product categories', 'cheshalo' ); ?>
			</option>
			<option value="product_tags">
				<?php esc_html_e( 'Product tags', 'cheshalo' ); ?>
			</option>
			<option value="product_attr">
				<?php esc_html_e( 'Product attribute', 'cheshalo' ); ?>
			</option>
			<option value="product_term">
				<?php esc_html_e( 'Product term (category, tag, attribute)', 'cheshalo' ); ?>
			</option>
			<option value="product_cat_children">
				<?php esc_html_e( 'Child product categories', 'cheshalo' ); ?>
			</option>
			<option value="filtered_product_term">
				<?php esc_html_e( 'Filtered by attribute', 'cheshalo' ); ?>
			</option>
			<option value="filtered_product_by_term">
				<?php esc_html_e( 'Filtered by term', 'cheshalo' ); ?>
			</option>
			<option value="filtered_product_term_any">
				<?php esc_html_e( 'Filtered by any attribute', 'cheshalo' ); ?>
			</option>
			<option value="filtered_product_stock_status">
				<?php esc_html_e( 'Filtered by stock status', 'cheshalo' ); ?>
			</option>
		</select>

		<select class="xts-layout-condition-type" name="wd_layout_condition_type" data-type="single_product" aria-label="<?php esc_attr_e( 'Condition type', 'cheshalo' ); ?>">
			<option value="all">
				<?php esc_html_e( 'All products', 'cheshalo' ); ?>
			</option>
			<option value="product">
				<?php esc_html_e( 'Single product id', 'cheshalo' ); ?>
			</option>
			<option value="product_cat">
				<?php esc_html_e( 'Product category', 'cheshalo' ); ?>
			</option>
			<option value="product_cat_children">
				<?php esc_html_e( 'Child product categories', 'cheshalo' ); ?>
			</option>
			<option value="product_tag">
				<?php esc_html_e( 'Product tag', 'cheshalo' ); ?>
			</option>
			<option value="product_attr_term">
				<?php esc_html_e( 'Product attribute', 'cheshalo' ); ?>
			</option>
			<option value="product_type">
				<?php esc_html_e( 'Product type', 'cheshalo' ); ?>
			</option>
		</select>

		<select class="xts-layout-condition-type" name="wd_layout_condition_type" data-type="checkout_form" aria-label="<?php esc_attr_e( 'Condition type', 'cheshalo' ); ?>">
			<option value="checkout_form">
				<?php esc_html_e( 'Checkout page form', 'cheshalo' ); ?>
			</option>
		</select>

		<select class="xts-layout-condition-type" name="wd_layout_condition_type" data-type="checkout_content" aria-label="<?php esc_attr_e( 'Condition type', 'cheshalo' ); ?>">
			<option value="checkout_content">
				<?php esc_html_e( 'Checkout page content', 'cheshalo' ); ?>
			</option>
		</select>

		<select class="xts-layout-condition-type" name="wd_layout_condition_type" data-type="cart" aria-label="<?php esc_attr_e( 'Condition type', 'cheshalo' ); ?>">
			<option value="cart">
				<?php esc_html_e( 'Cart page', 'cheshalo' ); ?>
			</option>
		</select>

		<select class="xts-layout-condition-type" name="wd_layout_condition_type" data-type="empty_cart" aria-label="<?php esc_attr_e( 'Condition type', 'cheshalo' ); ?>">
			<option value="empty_cart">
				<?php esc_html_e( 'Empty cart page', 'cheshalo' ); ?>
			</option>
		</select>

		<select class="xts-layout-condition-query xts-hidden" name="wd_layout_condition_query" placeholder="<?php echo esc_attr__( 'Start typing...', 'cheshalo' ); ?>" aria-label="<?php esc_attr_e( 'Condition query', 'cheshalo' ); ?>"></select>

		<a href="javascript:void(0);" class="xts-layout-condition-remove xts-bordered-btn xts-color-warning xts-style-icon xts-i-close" title="<?php esc_attr_e( 'Remove condition', 'cheshalo' ); ?>"></a>
	</div>
</div>
