/* global cheshalo_settings */
(function($) {
	cheshaloThemeModule.$document.on('wdShopPageInit', function() {
		cheshaloThemeModule.sortByWidget();
	});

	cheshaloThemeModule.sortByWidget = function() {
		if (!cheshaloThemeModule.$body.hasClass('cheshalo-ajax-shop-on') || typeof ($.fn.pjax) == 'undefined') {
			return;
		}

		var $wcOrdering = $('.woocommerce-ordering');

		$wcOrdering.on('change', 'select.orderby', function() {
			var $form = $(this).closest('form');
			$form.find('[name="_pjax"]').remove();

			$.pjax({
				container: '.main-page-wrapper',
				timeout  : cheshalo_settings.pjax_timeout,
				url      : '?' + $form.serialize(),
				scrollTo : false,
				renderCallback: function(context, html, afterRender) {
					cheshaloThemeModule.removeDuplicatedStylesFromHTML(html, function(html) {
						context.html(html);
						afterRender();
						cheshaloThemeModule.$document.trigger('wdShopPageInit');
						cheshaloThemeModule.$document.trigger('wood-images-loaded');
					});
				}
			});
		});

		$wcOrdering.on('submit', function(e) {
			e.preventDefault(e);
		});
	};

	$(document).ready(function() {
		cheshaloThemeModule.sortByWidget();
	});

	window.addEventListener('popstate', function() {
		cheshaloThemeModule.sortByWidget();
	});
})(jQuery);
