/* global cheshalo_settings */
(function($) {
	cheshaloThemeModule.$document.on('wdHeaderBuilderInited', function () {
		cheshaloThemeModule.stickyDetails();
	});

	cheshaloThemeModule.stickyDetails = function() {
		if (!cheshaloThemeModule.$body.hasClass('cheshalo-product-sticky-on') || cheshaloThemeModule.$window.width() <= 1024) {
			return;
		}

		var details = $('.entry-summary');

		details.each(function() {
			var $column = $(this),
			    offset  = parseInt(cheshalo_settings.sticky_product_details_offset),
			    $inner  = $column.find('.summary-inner'),
			    $images = $column.parent().find('.woocommerce-product-gallery');

			$inner.trigger('sticky_kit:detach');
			$images.trigger('sticky_kit:detach');

			$images.imagesLoaded(function() {
				var diff = $inner.outerHeight() - $images.outerHeight();

				if (diff < -100) {
					$inner.stick_in_parent({
						offset_top: offset
					});
				} else if (diff > 100) {
					$images.stick_in_parent({
						offset_top: offset
					});
				}

				cheshaloThemeModule.$window.on('resize', cheshaloThemeModule.debounce(function() {
					if (cheshaloThemeModule.$window.width() <= 1024) {
						$inner.trigger('sticky_kit:detach');
						$images.trigger('sticky_kit:detach');
					} else if ($inner.outerHeight() < $images.outerHeight()) {
						$inner.stick_in_parent({
							offset_top: offset
						});
					} else {
						$images.stick_in_parent({
							offset_top: offset
						});
					}
				}, 300));
			});
		});
	};

	$(document).ready(function() {
		cheshaloThemeModule.stickyDetails();
	});
})(jQuery);
